Index: tag/rc_1/Podgorski
===================================================================
--- tag/rc_1/Podgorski	(nonexistent)
+++ tag/rc_1/Podgorski	(revision 517)
@@ -0,0 +1,265 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include <math.h>
+#include "trame.h"
+
+typedef struct {
+    float latitude;
+    float longitude;
+} Position ;
+
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+
+
+
+
+
+
+int power(int n){
+    int i,res=1;
+    for(i=0;i<n;i++){
+        res*=10;
+
+    }
+    return res;
+}
+
+int decode_int(char a){
+
+    int b=a;
+    if(48<=b && b<=57){
+        b-=48;
+    }
+    else{
+        b=-1;
+    }
+    return b;
+}
+
+int decode_nombre(char *ch,int n,int i){
+
+    int res=0;
+    for(i;i<n;i++){
+
+        res+=decode_int(ch[i])*power(n-i-1);
+    }
+    return res;
+}
+
+
+float conversion_latitude_flottant(char *trame){
+    int i,j=0,k=0;
+    char t[4];
+
+    // On stocke l'indice du premier caractère de la latitude contenue dans la trame dans j
+
+    while(k<2){
+
+        if(trame[j]==','){
+            k+=1;
+        }
+        j+=1;
+    }
+
+    // On convertit la chaîne latitude en flottant. La latitude est contenue dans la trame à partir de l'indice j
+
+    float res=decode_nombre(trame,j+2,j);
+
+
+    for(i=2;i<4;i++){
+        t[i-2]=trame[i+j];
+    }
+    res+=((float)decode_nombre(t,2,0)/60);
+
+    for(i=5;i<9;i++){
+        t[i-5]=trame[i+j];
+    }
+
+    res+=((float)decode_nombre(t,4,0)/360000);
+
+    return res;
+}
+
+float conversion_longitude_flottant(char *trame){
+    int i,j=0,k=0;
+    char t[4];
+
+    // On stocke l'indice du premier caractère de la longitude contenue dans la trame dans j
+
+    while(k<4){
+
+        if(trame[j]==','){
+            k+=1;
+        }
+        j+=1;
+    }
+
+    // On convertit la chaîne longitude en flottant. La longitude est contenue dans la trame à partir de l'indice j
+
+    float res=decode_nombre(trame,j+3,j);
+
+
+    for(i=3;i<5;i++){
+        t[i-2]=trame[i+j];
+    }
+    res+=((float)decode_nombre(t,2,0)/60);
+
+    for(i=6;i<10;i++){
+        t[i-5]=trame[i+j];
+    }
+
+    res+=((float)decode_nombre(t,4,0)/360000);
+
+    return res;
+}
+
+void decode_trame(char * trame, Position *p){
+
+    if(trame_cmp(trame,"GPGGA")==1){
+        p->latitude=conversion_latitude_flottant(trame);
+        p->longitude=conversion_longitude_flottant(trame);
+    }
+}
+
+float calcule_distance(Position p_1, Position p_2){
+
+    return(pow(( ((p_1.latitude-p_2.latitude)*(p_1.latitude-p_2.latitude)) + ((p_1.longitude-p_2.longitude)*(p_1.longitude-p_2.longitude)) ),0.5));
+
+}
+
+int trame_cmp(char *trame, char *type){
+
+    int i,test=1;
+
+    for(i=0;i<5;i++){
+
+        if(trame[i+1]!=type[i]){
+
+            test=0;
+
+        }
+
+    }
+    return(test);
+}
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+    static int cpt=0 ;
+    cpt++ ;
+    if(trame_cmp(trame,"GPGGA")==1){
+        printf ("> %s\n",trame);
+    }
+}
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void){
+    if (5!=5){
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$APRMC...", "GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp.\n");
+        exit(-1);
+    }
+    test_decode_int();
+    test_decode_nombre();
+    test_conversion_latitude();
+
+    Position P1;
+    Position P2;
+
+    decode_trame("$GPGGA,141914.00,4851.3100,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D", &P1);
+    decode_trame("$GPGGA,141914.00,4850.3100,N,00506.6036,E,1,05,3.4,499.3,M,,M,,*7D", &P2);
+    //printf("%f\n",P1.latitude);
+    //printf("%f\n",P2.latitude);
+    //printf("%f\n",P1.longitude);
+    //printf("%f\n",P2.longitude);
+}
+
+void test_conversion_latitude(void){
+
+    if (abs(conversion_latitude_flottant("$GPGGA,141914.00,4851.3100,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D")-48.85861111)>0.00001){
+        printf ("Erreur Test unitaire conversion latitude.\n");
+        exit(-1);
+    }
+}
+
+void test_decode_int(void){
+
+    if (decode_int('1')!=1){
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if (decode_int('9')!=9){
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+    if (decode_int('A')!=-1){
+        printf ("Erreur Test unitaire decode_int.\n");
+        exit(-1);
+    }
+}
+
+void test_decode_nombre(void){
+
+    if (decode_nombre("123",2,0)!=12){
+        printf ("Erreur Test unitaire decode_nombre n°1 : %d\n",decode_nombre("123",2,0));
+        exit(-1);
+    }
+    if (decode_nombre("987654321",2,0)!=98){
+        printf ("Erreur Test unitaire decode_nombre n°2.\n");
+        exit(-1);
+    }
+    if (decode_nombre("66543",4,0)!=6654){
+        printf ("Erreur Test unitaire decode_nombre n°3.\n");
+        exit(-1);
+    }
+}
+
+// Ne pas modifier cette fonction
+int main(int argc,char ** argv)
+{
+
+    tests_unitaires();
+
+    // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
+
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
+        traitement(trame);
+
+    return 0;
+}